#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <ctype.h>

#define MAXCAPITALIZEBUFFER 100

void capitalizebuffer(char * buffer, uint8_t length) {
    char buffer2[MAXCAPITALIZEBUFFER];
    memset(buffer2, 0, MAXCAPITALIZEBUFFER);

    strncpy(buffer2, buffer, length);

    int i = 0;
    while (buffer2[i]) {
        printf("%c", toupper(buffer2[i]));
        i++;
    }
    printf("\n");
    printf("Done printing\n");
    return;
}


int main(int argc, char** argv) {
    FILE *fp;
	fp = fopen("test.file", "rb");

	if (fp == NULL) {
		perror("Could not open file\n");
        exit(EXIT_FAILURE);
	}

    fseek( fp , 0L , SEEK_END);
    long lSize = ftell( fp );
    rewind( fp );

    int8_t length = 0;

    fread(&length, sizeof(int8_t), 1, fp);

    char* buffer = (char*) malloc(lSize);

    if( 1!=fread( buffer , lSize - 1, 1 , fp) ) {
        fclose(fp);
        printf("Could not read file\n");
        return -1;
    }
   
    if (length > MAXCAPITALIZEBUFFER) {
        printf("length field too big\n");
        return -1;
    }
    
    capitalizebuffer(buffer, length);

    fclose(fp);
    free(buffer);
    return 0;
}
